#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";



my $query;
$query = new CGI;


#get the submitted color selections
my $namecolor = $query->param("ncolor");
my $fontcolor = $query->param("fcolor");
my $newpref=0;
if($namecolor && $fontcolor){
    $newpref=1; #if we got new colors then set the prefs and continue
}

my $isLogin = isLoggedin();
my $db=connecttodatabase();

my $user=hasCookie();
my $isAlreadyLogin=chatLoggedIn();

my $username=getUsername($user);



if($newpref && $isLogin){ #if the user is logged in and set prefs
    #insert their choice into the database
    $db->query("insert into chatuserpreferences(userid,namecolor,fontcolor) values($user,'$namecolor','$fontcolor')");
    
}

my $isbooted = chatBooted(); #check to see if they were booted from the chatroom


#check if they are logged in/not already in the chat room and not booted
if($isLogin && !$isAlreadyLogin && !$isbooted){
    my $chatps = $db->query("select * from chatuserpreferences where userid=$user");
    if($chatps->FetchRow){ #if they have preferences then let them into the chat

	#first insert them into the chat users table (this puts them in the chat)
	$db->query("insert into chatusers(userid,logintime,lastactive,username,ipaddress) values($user,now(),now(),'$username','$ENV{REMOTE_ADDR}')");
	#then store the info in the lurker
	$db->query("insert into lurkerchatusers(userid,logintime,ipaddress) values($user,now(),'$ENV{REMOTE_ADDR}')");
	
	print_html("headers");  
	my %result = getCourseInfo();
	
	
	my $coursename = $result{coursename};
	
	print "<html><head><title>$coursename</title>";
	print_html("stylesheet");
	print "</head>";
	

	#the body on unload will log the user our when the body is closed
	#three iframes are set up, one has the actual content of the chat
	#another has the dialog for entering text to the chat
	#and the third is the list of all users
	print <<HTML;
	<body onUnLoad="window.location='chatlogout.cgi'">
	    <iframe class="chatwindow" src="chatwindow.cgi" scrolling=no></iframe>
	    <iframe class="chatusers" src="chatusers.cgi"></iframe>
	    <iframe class="chatdialog" src="chatdialog.cgi" ></iframe>

	    <div class="chatwelcome"><a href="">Leave the Chat</a></div>



HTML

    

    

print_html("endhtml");	
#inform everyone that the user has entered the chat
	my $timeres=$db->query("select now()");
	my $time=parse_time($timeres->FetchRow); 	 
	$db->query("update chatlogs set logtext=concat('<span color=\"black\"> $time: $username entered chat<br></span>\n',logtext) where inuse=1");
	
    }
    else { #if they haven't yet made their color selection display the selection dialog
	print_html("ofcourse");
	print_html("stylesheet");
	print <<HTML;

	<form method=post>
	    <table border=1>
	    <tr>
	    <td colspan=2 align=center>You will only see this option once
	    </td></tr> 
	    <tr>
	    <td>Please select which color you <br>
	    would like your name to be:</td>
	    <td valign=middle>
	    <span class="chatcolor1bg">
	    <input type=radio value="chatcolor1" name="ncolor">
	    </span>&nbsp;	
	<span class="chatcolor2bg";>
	    <input type=radio value="chatcolor2" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor3bg";>
	    <input type=radio value="chatcolor3" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor4bg";>
	    <input type=radio value="chatcolor4" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor5bg";>
	    <input type=radio value="chatcolor5" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor6bg";>
	    <input type=radio value="chatcolor6" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor7bg";>
	    <input type=radio value="chatcolor7" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor8bg";>
	    <input type=radio value="chatcolor8" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor9bg";>
	    <input type=radio value="chatcolor9" name="ncolor">
	    </span>&nbsp;
	<span class="chatcolor10bg";>
	    <input type=radio value="chatcolor10" name="ncolor">
	    </span>&nbsp;
	</td>
	    </tr>
	    <tr>
	    <td align=center>Please choose a default <br>color for your text:</td>
	    <td valign=middle>
	    <span class="chatcolor1bg">
	    <input type=radio value="chatcolor1" name="fcolor">
	    </span>&nbsp;	
	<span class="chatcolor2bg";>
	    <input type=radio value="chatcolor2" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor3bg";>
	    <input type=radio value="chatcolor3" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor4bg";>
	    <input type=radio value="chatcolor4" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor5bg";>
	    <input type=radio value="chatcolor5" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor6bg";>
	    <input type=radio value="chatcolor6" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor7bg";>
	    <input type=radio value="chatcolor7" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor8bg";>
	    <input type=radio value="chatcolor8" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor9bg";>
	    <input type=radio value="chatcolor9" name="fcolor">
	    </span>&nbsp;
	<span class="chatcolor10bg";>
	    <input type=radio value="chatcolor10" name="fcolor">
	    </span>&nbsp;
	    

	</td>
	    </tr>
	    <tr><td colspan=2 align=center><input type=submit value="Enter the chat room"></td>
	    </table>
	    
	    </form>
HTML

    }

}
elsif($isLogin) {
    if($isbooted){ #in the case that the user was booted
	#determin how long till they will be allowed to reenter and inform them
	#of this time
	print_html("ofcourse");
	my $expires  = bootexpiresafter();
	my $times = $db->query("select timebooted + INTERVAL $expires minute as time from bootedfromchat where userid=$user");
	my $time = $times->FetchRow;
	
	$time = parse_time($time);
	    
	    
	print "<div align=center class=\"bigger\">$username was removed from the chatroom.  You may not re-enter until after $time</div>";
	print_html("endhtml");

    }
    else { #if they werent booted then they must already be in the chat
    
	#check to see if they are the only one in the chat..if this is the
	#not the case then display them a message explaining what happend
	my $loggedinusers = $db->query("select * from chatusers where userid!=$user");
	if($loggedinusers->FetchRow){
	
	    
	    my %courseinfo=getCourseInfo();
	    print_html("ofcourse");
	    print "<div align=center class=\"bigger\">$username is already logged in to the chatroom";
	    print "</div>";
	    print "This can happen if you close your browser before you exit the chatroom or if someone else is using your id.  If you think someone else may be using your ID then contact the course instructor at <a href=\"mailto:$courseinfo{email}\">$courseinfo{email}</a>";
	    print_html("endhtml");
	
	}
	else { #if they are the only one in the chat
	    #assume that they want to start a new chat, boot the user which
	    #is currently in the chat, and redirect back to this page
	    $db->query("delete from chatusers where userid=$user");
	    
	    $db->query("update lurkerchatusers set logouttime=logintime + INTERVAL 10 minute where userid=$user and logouttime=-1");
	    my $timeres=$db->query("select now()");
	    my $time=parse_time($timeres->FetchRow);
	    my $username=getUsername($user);
	    $db->query("update chatlogs set logtext=concat('$time: $username left chat<br>',logtext) where inuse=1");
	    $db->query("update chatlogs set inuse=0,endtime=now() where inuse=1");
	    print "Location: chatroom.cgi\n\n";
	}
    }
    
    

}
else { #if they arent logged in send them to the login page
    print "Location: login.cgi?page=chatroom.cgi";
}



