#!pathtoperl   


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";


my$query;
$query = new CGI;


my $db = connecttodatabase();



my $isAdmin = isLoggedinAdmin();
my $sendoutmail=$query->param("sendmail");

my @foundtypes;
my $assres = $db->query("select distinct type from grades");
while(my $assigntype = $assres->FetchRow){
    push(@foundtypes,$assigntype);
}

my $mailer = "/usr/sbin/sendmail";
my $foundmailer=0;
if(-e $mailer){
    $foundmailer=1;
}

my %courseinfo=getCourseInfo();

if($courseinfo{sendmail}){
    $mailer=$courseinfo{sendmail};
    $foundmailer=1;
}



if($isAdmin){

    my $assignid=$query->param("assignid");
    


    print_html("ofcourse");
    print_html("stylesheet");
    print "<div align=center>";
    
   


    if(!$assignid){
	print "<h1>Assignments</h1>";
	print "<a href=\"printerfriendlygrades.cgi\" target=\"_blank\">Printer Friendly Version of all grades</a>";
	print "<br><table border=1 cellpadding=5 cellspacing=0>";
	 
	foreach(@foundtypes){
	    
	    my $typeres =  $db->query("select distinct assignid,assignname from grades where type='$_'");

	    print "<tr><th colspan=2 class=\"blue\">Assignment type: $_</th></tr>";
	    while(my %assignment = $typeres->FetchHash){
		print "<tr><td>$assignment{assignname}</td>";
		print "<td><a href=\"gradebook.cgi?assignid=$assignment{assignid}\">View this assignment</a></td></tr>";
		
	    }
	    
	    
	}
	print "</table>";
	
    }
    else {

	my %allusers;
	
	my $type;
	
	my $usersres=$db->query("select userid from users where isadmin!=1 and isapproved=1");
	my @arrayofusers;
	while(my $auser = $usersres->FetchRow){
	    $allusers{$auser}= 1;
	    push(@arrayofusers,$auser);

	}
	
	
	my $assignres=$db->query("select * from grades,users where grades.userid=users.userid and assignid=$assignid order by users.lastname");
	my $assigninfo=$db->query("select distinct assignname,points_possible from grades where assignid=$assignid");
	my $assname;
	my %assinfo=$assigninfo->FetchHash;
	my $posspoints=$assinfo{points_possible};
	print "<a href=\"gradebook.cgi\">Back to the gradebook</a>";
	print "<br><a href=\"printerfriendlygrades.cgi?assignid=$assignid\" target=\"_blank\">Print Assignment Grades</a>";
	print "<table border=1 cellpadding=5 cellspacing=0><tr><th class=\"blue\">Assignment Name:</th>";
	print "<td>$assinfo{assignname}</td></tr>";
	print "<tr><th class=\"blue\">Assignment type:</th>";
	my $assname=$assinfo{assignname};
	my $asstype = $db->query("select type from grades where assignname='$assinfo{assignname}'");
	my $asstypefornew=$asstype->FetchRow;
	print "<td>$asstypefornew</td></tr>";
	print "<th class=\"blue\">Possible points for<br>this assignment:</th><td align=center>$posspoints</td></tr></table>";
	print "<br><br>";
	print "<form name=\"allgrades\" action=\"updategrades.cgi\" method=post>";
	print "<table cellpadding=5 cellspacing=0 border=1><tr><th class=\"blue\">Lastname</th><th class=\"blue\">Firstname</th><th class=\"blue\">Username</th>";
	
	print "<th class=\"blue\">Points Earned</th>";
	print "<th class=\"blue\">Comments</th>";
	print "<td><input type=submit value=\"update all\"></td>";

	print "</tr>";
	
	my $paramcount = 0;

	print "<input type=hidden name=\"assignid\" value=\"$assignid\">";
	
	while(my %user = $assignres->FetchHash){
	    $type = $user{type};
	    $allusers{$user{userid}} = 0;
	    my $usersinfo = $db->query("select * from users where userid=$user{userid}");
	    my %info=$usersinfo->FetchHash;
	    my $scorename = "score" . $paramcount;
	    my $useridname = "userid" . $paramcount;
	    my $commentname = "comments" . $paramcount;
	 
	    
	    my $score=$user{points};
	    if ($score == -1){
		$score = "";
	    }
	    
	    print "<tr>";
	    print "<td align=left>$info{lastname}</td>";
	    print "<td align=left>$info{firstname}</td>";
	    print "<td align=left>$info{username}</td>";
	    
# print "<form action=\"updategrades.cgi\" method=post name=\"$paramcount\">";

	    
	    print "<td align=center><input type=text size=8 name=\"$scorename\" value=\"$score\"</td>";
	    print "<td align=center><textarea name=\"$commentname\" rows=2 cols=50>$user{comments}</textarea></td>";
	    print "<input type=hidden name=\"$useridname\" value=\"$user{userid}\">";
	    print "<td align=center><input type=submit value=\"update\"></td>";
	   # print "</form>";
	    print "</tr>";
	
	    if($sendoutmail && $foundmailer && ($score ne "") && (($user{isdirty}==1)||($user{isdirty}==2))){
		$db->query("update grades set isdirty=0 where gid=$user{gid}");
		
		
		my $reply_to = $courseinfo{email};
		my $subject;
		if($user{isdirty}==2){
		    $subject = "Your grade for $courseinfo{coursename} Assignment: $assname has changed";
		}
		else {
		    $subject = "Your Grade for $courseinfo{coursename} Assignment: $assname";
		}
		my $to = "$info{email}";
		my $content = "Your Grade for $assname\n";
 		$content .=   "Grade for: $info{firstname} $info{lastname}\n";
		$content .=   " Username: $info{username}\n";
		if($user{isdirty}==2){
		    $content .=   "New Grade: $score out of $posspoints\n";
		}
		else {
		    $content .=   "    Grade: $score out of $posspoints\n";
		}
		$content .=   " Comments: $user{comments}\n";
		

		
		
		
		open(MAIL, "|$mailer -t");
		print MAIL "To: $to\n";
		print MAIL "Subject: $subject\n";
		print MAIL "From: Course Instructor\<$courseinfo{email}\>\n";
		print MAIL "$content\n";
		close(MAIL);
		
		
		

		
		
		
	    }
	    
	    
	    $paramcount++;
	}

	foreach (@arrayofusers){
	    if($allusers{$_}){
		#print "entered here $asstypefornew";
		$db->query("insert into grades(userid,assignid,type,points_possible,assignname,points) values($_,$assignid,'$asstypefornew',$posspoints,'$assinfo{assignname}',-1)");
		my $usersinfo = $db->query("select * from users where userid=$_");
		
		my %info=$usersinfo->FetchHash;
		my $scorename = "score" . $paramcount;
		my $useridname = "userid" . $paramcount;
		my $commentname = "comments" . $paramcount;
		
		print "<tr>";
		print "<td align=left>$info{lastname}</td>";
		print "<td align=left>$info{firstname}</td>";
		print "<td align=left>$info{username}</td>";
		# print "<form action=\"updategrades.cgi\" method=post name=\"$paramcount\">";
		
		
		print "\n<td align=center><input type=text size=8 name=\"$scorename\" value=\"\"></td>";
		print "\n<td align=center><textarea name=\"$commentname\" rows=2 cols=50></textarea></td>";
		print "\n<input type=hidden name=\"$useridname\" value=\"$_\">";
		print "\n<td align=center><input type=submit value=\"update\"><td>";
		# print "</form>";
		print "</tr>\n\n";
		
		$paramcount++;
		
		
	    }
	    
	}
	

	print "<input type=hidden name=\"maxparam\" value=\"$paramcount\">";
	print "</form>";
	print "</table>";
	if($foundmailer){
	    print "<form method=post><input type=hidden name=\"assignid\" value=\"$assignid\"><input type=hidden name=\"sendmail\" value=1>";
	    print "<input type=submit value=\"Mail these grades to the students\">"; 
	    print "<br>Only students who have received a grade will be sent an email, sending mail again will not send a repeat email unless a users grade has changed.<br></form>";
	}

    }



    print "<form action=\"newassignment.cgi\" method=post>";
    print "<table><tr><th colspan=3 class=\"blue\">Add a new assignment</th></tr>";
    print "<tr>";
    print "<td align=right>Assignment name:</td>";
    print "<td colspan=2><input type=text name=\"assname\" size=50></td>";
    print "</tr>";
    print "<tr>";
    print "<td align=right>Possible Points:</td>";
    print "<td align=left colspan=2><input type=text name=\"points\" size=5 value=100></td>";
    print "</tr>";
    print "<tr>";
    print "<td align=right>Type:</td>";
    print "<td align=left><select name=\"type\">";
    
    foreach (@foundtypes){
	print "<option>$_</option>";
    }
    print "<option>Other</option>";
    print "</select>";
    print "</td><td align=right><input type=submit class=\"standardbutton\" value=\"Create new assignment\"></td></tr>";
    print "</form>";
    print "</table>";
    
    
    

    print "<div>";
    print_html("endhtml");
    
}
else {

    print "Location: login.cgi?gradebook.cgi\n\n";
}
