#!pathtoperl
use strict;
use CGI::Carp 'fatalsToBrowser';
use CGI;
require "./functions.cgi";

my $db = connecttodatabase();
#need to take in information on what forum you are in, then write to database by creating new post

my $query;
$query = new CGI;

#This is the threadname received from the HTML form
my $threadname = $query->param("threadname");

#This is the comments received from the HTML form
my $comments = $query->param("comments");

#This has a value if the person posted anonymously
my $isanon = $query->param("isanon");

#This is the topic id sent in as a hidden value from the HTML form
my $topicid = $query->param("topicid");

#If the user goes directly to the addnewthread.cgi link then topicid won't be there
#This is neccessary for added security
my $noinput = 0;

#Userid
my $user;

#If user is anonymous set isanon = 1 otherwise isanon = 0
if($isanon){
    $isanon = 1; 
}
else {
    $isanon = 0;
}

#Gets the userid or -1
$user = hasCookie();

#If there is no threadname or no comments then there is no input
if(!$threadname){
    $noinput = 1;
}

#Checks to make sure that a user is logged in
my $approved = isLoggedin();

#If there is an approved user and they input something
if($approved && !$noinput)
{
    #Get the maxthreadid from the database and adds 1 
    #All posts in the same thread will share the same threadid.
    #Since we are making a new thread we need to get an unused threadid number
    my $maxtid = $db->query("select max(threadid) from D_B_Posts");
    my $maxthreadid = $maxtid->FetchRow;
    $maxthreadid++;
    
    
    #Do the insert into the database
    $db->query("insert into D_B_Posts(threadid,topicid,userid,timeofpost,posttext,isanonymous,name,threadname) values($maxthreadid,$topicid,$user,now(),'$comments',$isanon,'$threadname','$threadname')");
    
    #Redirects user back to threads.cgi with their post being displayed.
    print "Location: posts.cgi?threadid=$maxthreadid\n\n";
    
}
#if the user is not approved or they did not send anything then....
else{

    #If there is no iput send them back to the discussion page
    if($noinput){
     #Redirects user back to discussion page
	print "Location: login.cgi?page=threads.cgi?topic=$topicid\n\n";
    }
    #If there is input and the user is not approved redirect to the login page
    else{
	#Redirects user to login page
	print "Location: login.cgi\n\n";
    }
}
