#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";
my $isAdmin = isLoggedinAdmin();
my $query;
$query = new CGI;
my $db = connecttodatabase();

#if the Administrator tries to access the page 
if($isAdmin){
    print_html("ofcourse");
    
    
    #User to be approved or disapproved, initially null
    my $modifiedUser = $query->param("user");
    
    #Value of submitted button either approve or disapprove, initially null
    my $submitted    = $query->param("submit");
    
    #If the user to be approved/disapproved is not null 
    if($modifiedUser){
	
	if($submitted eq "Approve"){
	    #Update the database to reflect there approved status and print a line to the user
	    
	    $db->query("update users set isapproved = 1 where userid=$modifiedUser;");
	    
	    my $results = $db->query("select userid, firstname, lastname, username, email from users where userid = $modifiedUser;");
	    my %user = $results->FetchHash;
	    print"<STYLE TYPE=text/css>.header{color: red; text-align: center;}</STYLE>";
	    print "<H1 class=header>$user{firstname} $user{lastname} has been approved, with the username $user{username}.</H1><BR>";
	}
	elsif ($submitted eq "Make Admin"){
	    #make the submitted user an admin
	    $db->query("update users set isadmin=1 where userid=$modifiedUser");
	    

	}	
	elsif ($submitted eq "Remove Admin Status"){
	    #remove admin status
	    $db->query("update users set isadmin=0 where userid=$modifiedUser");
	}
	else{


	    #Update the database to reflect there disapproved status
	    
	    $db->query("update users set isapproved = -1 where userid=$modifiedUser;");
	    
	    my $results = $db->query("select userid, firstname, lastname, username, email from users where userid = $modifiedUser;");
	    my %user = $results->FetchHash;
	    print"<STYLE TYPE=text/css>.header{color: red; text-align: center;}</STYLE>";
	    print "<H1 class=header>$user{firstname} $user{lastname} has been DISAPPROVED.</H1><BR>";
	}
	
    }
    #Print the begining HTML page
    print "
 	    <DIV align=center>
            
            <a name=\"top\"></a>
            <a href=\"#approved\">Approved Users</a>&nbsp;&nbsp;
            <a href=\"#admin\">Instructor Listing</a>&nbsp;&nbsp;
            <a href=\"#disapproved\">Disapproved Users</a>
            <P><B>If you would like to approve a student simply click the approve button, if you would like to disaprove a student then click the disaprove button.</B></P>
	    <TABLE border=1 cellspacing=0 cellpadding=3 width=85%>	
	    <TR><TH colspan=2 width=32%>Approve/Disaprove</TH><TH width=16%>First Name</TH><TH width=16%>Last Name</TH><TH width=16%>Username</TH><TH width=16%>Email</TH></TR>
	";
    
    #Get the list of unapproved users from the database
    my $results = $db->query("select userid, firstname, lastname, username, email from users where isapproved = 0;");
    
    #For each unapproved user print a table row with their information and an approve and disaprove button
    while(my %user = $results->FetchHash){
	my $userid = $user{userid};
	
	print "

	    <form action=\"approve.cgi\" method=post>
	
	    <TR><input type=hidden name=\"user\" value=$userid>
	      <TD align=center><input type=submit name=\"submit\" value=\"Approve\"></TD>
 	      <TD align=center><input type=submit name=\"submit\" value=\"Disaprove\"></TD>    
	      <TD>&nbsp; $user{firstname}</TD>
	      <TD>&nbsp;$user{lastname}</TD>
	      <TD >&nbsp;$user{username}</TD>
	      <TD >&nbsp;$user{email}</TD>
	    </TR>    
	   </form>
	  "; #close print
	
    }
    
    #End html table
    print "
	   </TABLE><BR><a href=\"#top\">Top of the page</a><BR>
	";
    
        
    print "
          <a name=\"approved\"></a>
            <P><B>The following users have been approved, you can modify their status here.</B></P>
	    <TABLE border=1 cellspacing=0 cellpadding=3 width=85%>	
	    <TR><TH width=16%>Disaprove</th><th width=16%>Make Instructor</th><TH width=16%>First Name</TH><TH width=16%>Last Name</TH><TH width=16%>Username</TH><TH width=16%>Email</TH></TR>
	";
    
#Get the list of disapproved users from the database
    my $results = $db->query("select userid, firstname, lastname, username, email from users where isapproved = 1 and isadmin=0;");
    
    #For each disapproved user print a table row with their information and an approve button
    while(my %user = $results->FetchHash){
	my $userid = $user{userid};
	
	print "
	
	    <form action=\"approve.cgi\" method=post>
		
	    <TR><input type=hidden name=\"user\" value=$userid>
	       <TD align=center><input type=submit name=\"submit\" value=\"Disapprove\"></TD>

";
	
	print "<td align=center><input type=submit name=\"submit\" value=\"Make Admin\"></td>";
	print "
	       <TD width=100>&nbsp; $user{firstname}</TD>
	       <TD width=100>&nbsp;$user{lastname}</TD>
	       <TD width=100>&nbsp;$user{username}</TD>
	       <TD width=100>&nbsp;$user{email}</TD>
	   </TR>    
			
	   </form>
		
	  "; #close print
	
    }
    
    #Closes html page
    print "
           </TABLE><br><a href=\"#top\">Top of page</a><br>

";
    
    
#Print a table with all disaproved users
    print "
          <a name=\"admin\"></a>
	  <P align=center><B>The following users are listed as instructors if you would like to remove their instructor status you can do so here.</B></P>
	  <TABLE border=1 cellspacing=0 cellpadding=3 width=85%>	
	  <TR><TH width=32% colspan=2>Remove Admin Status</TH><TH width=16%>First Name</TH><TH width=16%>Last Name</TH><TH width=16%>Username</TH><TH width=16%>Email</TH></TR>
	";
  
    #Get the list of admin users from the database
    my $results = $db->query("select userid, firstname, lastname, username, email from users where isadmin = 1;");
    
    #For each admin user that is not the initial instructor (userid 1) print a table row with their information and a remove admin status button
    while(my %user = $results->FetchHash){
	my $userid = $user{userid};
	if($userid==1){
	    print "<tr><td colspan=2 align=center>You cannot change this user</td>";
	    print "
               <TD width=100>&nbsp; $user{firstname}</TD>
	       <TD width=100>&nbsp;$user{lastname}</TD>
	       <TD width=100>&nbsp;$user{username}</TD>
	       <TD width=100>&nbsp;$user{email}</TD>
             </tr>
";
	}
	else {
	    print "
	
	    <form action=\"approve.cgi\" method=post>
		
	    <TR><input type=hidden name=\"user\" value=$userid>
	       <TD align=center colspan=2><input type=submit name=\"submit\" value=\"Remove Admin Status\"></TD>
	       <TD width=100>&nbsp; $user{firstname}</TD>
	       <TD width=100>&nbsp;$user{lastname}</TD>
	       <TD width=100>&nbsp;$user{username}</TD>
	       <TD width=100>&nbsp;$user{email}</TD>
	   </TR>    
			
	   </form>
		
	  "; #close print
	    
	}
    }
	 #Closes html page
    print "
           </TABLE><br><a href=\"#top\">Top of the page</a><br>
";


#Print a table with all disaproved users
    print "
          <a name=\"disapproved\"></a>
	  <P align=center><B>The following users have been Disaproved if you would like to approve them click the approve button</B></P>
	  <TABLE border=1 cellspacing=0 cellpadding=3 width=85%>	
	  <TR><TH width=32% colspan=2>Approve</TH><TH width=16%>First Name</TH><TH width=16%>Last Name</TH><TH width=16%>Username</TH><TH width=16%>Email</TH></TR>
	";
  
    #Get the list of disapproved users from the database
    my $results = $db->query("select userid, firstname, lastname, username, email from users where isapproved = -1;");
    
    #For each disapproved user print a table row with their information and an approve button
    while(my %user = $results->FetchHash){
	my $userid = $user{userid};
	
	print "
	
	    <form action=\"approve.cgi\" method=post>
		
	    <TR><input type=hidden name=\"user\" value=$userid>
	       <TD align=center colspan=2><input type=submit name=\"submit\" value=\"Approve\" class=\"standardbutton\"></TD>
	       <TD width=100>&nbsp; $user{firstname}</TD>
	       <TD width=100>&nbsp;$user{lastname}</TD>
	       <TD width=100>&nbsp;$user{username}</TD>
	       <TD width=100>&nbsp;$user{email}</TD>
	   </TR>    
			
	   </form>
		
	  "; #close print
	
    }
    
	 #Closes html page
    print "
           </TABLE><br><a href=\"#top\">Top of the page</a><br>";
    
    print "

           </DIV>
<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>
<br><br><br><br><br><br><br><br><br><br><br><br>
           </BODY>
	   </HTML>
	";
}

else{
    print_html("headers");
    print_html("coursehead");
    print_html("buttons");
    <DIV align=center>; 
    print "<H1>You are not an administrator</H1><BR>";
    print '<H1><A HREF=mechanics101.html>Back to Home Page</A></H1>';
	
	print "
		</DIV>
	   </BODY>
	   </HTML>
	   ";
}
