#!pathtoperl   -T
 

use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";

my$query;
$query = new CGI;

#get any information passed to the script
my $page  = $query->param("page"); #page the user intends to visit
my $username = $query->param("username");
my $password = $query->param("password");
my $returntohome = 0;



my $db = connecttodatabase();

my $displaylogin = 1; #assume that the user wants to use the login form
my $printerror = 0; #assume that we will not need to print the error
my $errormessage; #the error to print
my $id = hasCookie(); #check to see which user is visiting the site 

if(!$id){ #if no cookie was found than set id to -1
    $id=-1;
}


print_html("headers"); #print the content headers
print_html("coursehead"); #open html


#first check to see if there is a new form submission
if($username) { 
#if we received a form submission
    my $uresult = $db->query("select password,isapproved from users where username=\"$username\""); #get the users password and the isapproved value for username
    my $validlogin = 0; #assume invalid login
    my $validpw =0; #assume invalid password
    if(my %hash = $uresult->FetchHash){ #if we found the user in the database
	$validlogin = 1; #if we found it then the login is valid
	if($password eq $hash{password}) { #here is where we check the password
	    $validpw = 1;  
	}
    }
    if($validlogin){ #if the login was valid
	if($validpw){ #and the password was correct
	    my $idres = $db->query("select userid from users where username='$username'");
	    my $idnumber = $idres->FetchRow;
	    my $idres = $db->query("select md5('$idnumber')"); 
	 
	    my $checksumid = $idres->FetchRow; #get the checksum value 
	    #write the script to set the cookie and redirect back to login.cgi
	    #passing along the intended page.  (in order to check if the user
	    #is approved)
	    if(!$page){ #if no page specified, return to mainpage
		my %res = getCourseInfo();
		$page = $res{mainpage};
		my $returntohome=1;
	    }
	    
	    #store successful login in lurker database
	    $db->query("insert into lurker_logins(username,timeoflogin,loginip,loginhost,success) values('$username',now(),'$ENV{REMOTE_ADDR}','$ENV{REMOTE_HOST}',1)");
	    if($returntohome){

	    print <<HTML; 
		<script>
		    document.cookie = "userinfo=$checksumid;expires=Thu, 31  Aug 2020 23:59:59 UTC";
	    parent.document.location = 'login.cgi?page=$page';
	
		</script>  
HTML
}
	    else {
	 print <<HTML; 
		<script>
		    document.cookie = "userinfo=$checksumid;expires=Thu, 31  Aug 2020 23:59:59 UTC";
	    document.location = 'login.cgi?page=$page';
	
		</script>  
HTML
	

	    }

}
	else { #wrong password
	    #store wrong password in lurker table
	    $db->query("insert into lurker_logins(username,timeoflogin,loginip,loginhost,success) values('$username',now(),'$ENV{REMOTE_ADDR}','$ENV{REMOTE_HOST}',-1)");

	    $printerror=1; 
	    $errormessage = "<div align=center>Incorrect password<br></div>";
	}
    }
    else { #invalid username
	#store invalid username in lurker table
	$db->query("insert into lurker_logins(username,timeoflogin,loginip,loginhost,success) values('$username',now(),'$ENV{REMOTE_ADDR}','$ENV{REMOTE_HOST}',0)");

	$printerror=1; 
	$errormessage = "<div align=center>Invalid username<br></div>";
	$username = "";
    }
}
elsif($id != -1){ #else check if we found a cookie
    my $islogin = isLoggedin(); #check to see if the user is already logged in
    my $isDis   = isDisapproved($id); #check to see if the user cant login
    my $isPend  = isPendingApproval($id); # ...
    $displaylogin = 0; #don't display the login page
    
    if($islogin){ #if the user is logged in
	if($page){ #redirect them to their intended page
	    if($returntohome){
		print "<script>parent.document.location = '$page';</script>";
	    }
	    else {
		
		print "<script>document.location = '$page';</script>";
	    }
	}
	else { 
#if no page was specified then the user actually wants to view the login page
	    $displaylogin = 1;
	}
    }
    elsif($isDis){ #if the user was disapproved then inform them

	my %courseinfo = getCourseInfo();
	my $email = $courseinfo{email};
	$printerror = 1;
	$errormessage =  "<div align=center>Your account has been disapproved and you may not log in.  Contact the course instructor at $email if you are still interested in registering<br><br></div>";
	$displaylogin = 1;
    }
    elsif($isPend){ #if the user is pending then inform them 
	$displaylogin = 1;
	$printerror=1;
	$errormessage =  "<div align=center>Your account is pending approval.</div><br><br>";
    }
}



#if we still want to display the login page
if($displaylogin){
    print_html("loginbuttons");
    if($printerror){
	print "$errormessage";

    }

    print <<HTML; #print the html form

<div align=center>
<img src="ofcourselogo.gif">
<br>
<br>
<table cellspacing=3>
<form action=login.cgi method=post>
<input type=hidden name=page value=$page>
<tr><td align=right>Username:</td><td><input name="username" type=text size=40 value=$username></td></tr>
<tr><td align=right>Password:</td><td><input name="password" type=password size=40></td></tr>
<tr><td colspan=2 align=center><input type=submit value="Login"></td></tr>
</form>
</table>
<br>

HTML

    print <<HTML;

</body>

</html>
HTML



}



